%clear all

path(path, '../htomo/work/mbin');

Nx=720;
Nz=560;

Nw=80;
Nt=4096;

w0=5 ;
wf=70 ;
npml=15;

Ns=29;

dx=250 ;
dz=250;
dt=0.01;

x0 = 80; xf = Nx-80;
z0 = 110; zf = Nz-50;
src=80:10:640;

%unix('mpirun -machinefile $PBS_NODEFILE -np 32 ./testadj.out par=mig.param.plane0')
if 1
ii=loadbin('/scratch/lustreA/s/sburdic/tmp/Iplane0S','float');
I0=reshape(ii,Nz,Nx,[]); % + i*reshape(I(2:2:end),Nz,Nx,Ns*2);
I=loadbin('/scratch/lustreA/s/sburdic/tmp/Iplane_adjPR','float');
ii=reshape(I,Nz,Nx,[]); % + i*reshape(I(2:2:end),Nz,Nx,Ns*2);
clear I

I =  ii(:,:,1:Ns);
dI = ii(:,:,Ns+1:end);
end


W=50;  
sigma = 20;
dep = 300;

  offs=zeros(Ns,Ns);
  
if  0
for ix=1:length(src) 
   for is=[1:10 20:Ns]%1:Ns %max(1,ix-12):min(length(src),ix+12)
	corr=zeros(1,2*W+1);
	for dz=-W:W
	  for iz=dep:dep+100
		
	    corr(dz+W+1)=corr(dz+W+1)+sum(I(iz+dz,src(ix),is)*I(iz,src(ix),(Ns+1)/2));
          end
          w1(dz+W+1) = (dz/W)^2;
          w2(dz+W+1) = -exp(-dz^2/sigma^2);
   	end
    	S(is,ix) = sum(corr.^2);
    	J(is,ix) = S(is,ix)^-1*sum(w2.*corr.^2);
    
	[tmp tmpi]=max(corr);
	offs(is,ix)=tmpi-W-1;
   end
end
end %if

J=zeros;dJ=zeros; S=zeros;
for ix= 10%1:length(src) 
   for is=10%[1:10 20:Ns]%1:Ns %max(1,ix-12):min(length(src),ix+12)
	dcorr=zeros(1,2*W+1);
	corr=zeros(1,2*W+1);
	for dz=-W:W
	  for iz=dep:dep+100
	    dcorr(dz+W+1)=dcorr(dz+W+1)+sum(I(iz+dz,src(ix),is)*dI(iz,src(ix),(Ns+1)/2));
	    dcorr(dz+W+1)=dcorr(dz+W+1)+sum(dI(iz+dz,src(ix),is)*I(iz,src(ix),(Ns+1)/2));
	    
	    corr(dz+W+1)=corr(dz+W+1)+sum(I(iz+dz,src(ix),is)*I(iz,src(ix),(Ns+1)/2));
          end
          w1(dz+W+1) = (dz/W)^2;
          w2(dz+W+1) = -exp(-dz^2/sigma^2);
   	end
    	S(is,ix) = sum(corr.^2);
    	dJ(is,ix) = S(is,ix)^-1*sum(w2.*dcorr.^2);
	J(is,ix) = S(is,ix)^-1*sum(w2.*corr.^2);
	dJ2(is,ix) = 2*S(is,ix)^-1*sum((w1-J(is,ix)).*corr);
	dJ2(is,ix) = 2*S(is,ix)^-1*sum((w1).*corr);
        %dJ(is,ix) = S(is,ix)^-1*sum(w2.*dcorr);
	
	[tmp tmpi]=max(corr);
	offs(is,ix)=tmpi-W-1;
   end
end


DI = zeros(size(dI));
for ix= 10%1:length(src)
    for is=10%[1:10 20:Ns]%1:Ns %max(1,ix-12):min(length(src),ix+12)
        Dcorr2 = zeros(1,2*W+1);
	for dz=-W:W
   	   Dcorr2(dz+W+1) = Dcorr2(dz+W+1) + S(is,ix)^-1*dJ(is,ix)*w2(dz+W+1);
	end
	for dz=-W:W	
	  for iz=dep:dep+100
	    DI(iz,src(ix),(Ns+1)/2)=DI(iz,src(ix),(Ns+1)/2)+Dcorr2(dz+W+1)*I(iz+dz,src(ix),is);
	    DI(iz+dz,src(ix),is)=DI(iz+dz,src(ix),is)+Dcorr2(dz+W+1)*I(iz,src(ix),(Ns+1)/2) ;
	  end
	end
    end
end
	    



sum(sum(dJ.^2))
sum(sum(sum(DI.*dI)))

