clear all

path(path, '../htomo/work/mbin');

Nx=720;
Nz=560;

Nw=80;
Nt=4096;

w0=4 ;
wf=80 ;
npml=15;

Ns=29;

dx=250 ;
dz=250;
dt=0.01;

x0 = 80; xf = Nx-80;
z0 = 110; zf = Nz-50;

srcap = 120;


srcx=srcap+1:10:Nx-srcap;
phi = linspace(-48, 48, Ns)*pi/180;
depz = 200:100:400;

xi = []; zi = []; si = []; 
for iz = 1:3;
  for ix = 1:length(srcx)
    for is = 1:Ns
      %if tan(abs(phi(is))) < abs(srcx(ix)-x0)/(depz(iz)-z0)
      if srcx(ix) > tan(abs(phi(is)))*(depz(iz)-z0+50) + srcap...
       & -srcx(ix) > tan(abs(phi(is)))*(depz(iz)-z0+50) - (Nx-srcap)
         xi=[xi srcx(ix)];
	 zi=[zi depz(iz)];
	 si=[si is];
      end
    end
  end
end
	     






%Load unperturbed case to I0
I=loadbin('/scratch/lustreA/s/sburdic/tmp/Iplane_adjPR0','float');
ii=reshape(I,Nz,Nx,[]); % + i*reshape(I(2:2:end),Nz,Nx,Ns*2);
clear I
I0 =  ii(:,:,1:Ns);
I=loadbin('/scratch/lustreA/s/sburdic/tmp/Iplane_adjPRf','float');
ii=reshape(I,Nz,Nx,[]); % + i*reshape(I(2:2:end),Nz,Nx,Ns*2);
clear I
If =  ii(:,:,1:Ns);

W=50;  
sigma = 40;



J0=zeros; S=zeros; Jf=zeros; Sf=zeros;
for nn=1:length(si)
  ix=xi(nn);
  is=si(nn);
	corr=zeros(1,2*W+1);
	corrf=zeros(1,2*W+1);
	for dz=-W:W
	  for iz=zi(nn):zi(nn)+100
		
	    %corr(dz+W+1)=corr(dz+W+1)+sum(I0(iz+dz,ix,is)*I0(iz,ix,(Ns+1)/2));
	    corrf(dz+W+1)=corrf(dz+W+1)+sum(If(iz+dz,ix,is)*If(iz,ix,(Ns+1)/2));
          end
          w1(dz+W+1) = (dz/W)^2;
          w2(dz+W+1) = -exp(-dz^2/sigma^2);
   	end
    	%S(nn) = sum(corr.^2);
	Sf(nn) = sum(corrf.^2);
    	%J0(nn) = S(nn)^-1*sum(w2.*corr.^2);
        Jf(nn) = Sf(nn)^-1*sum(w2.*corrf.^2);
  
end
%display(sprintf('No perturbation, J = %f',sum(sum(J0))))
display(sprintf('Test case, J = %f',sum(sum(Jf))))



for mm=1:8


if 1
%ii=loadbin('/scratch/lustreA/s/sburdic/tmp/Iplane0S','float');
%I0=reshape(ii,Nz,Nx,[]); % + i*reshape(I(2:2:end),Nz,Nx,Ns*2);
%I=loadbin('/scratch/lustreA/s/sburdic/tmp/Iplane_adjPR0','float');
I=loadbin(['/scratch/lustreA/s/sburdic/tmp/Iplane_adjPR' num2str(mm)],'float');
ii=reshape(I,Nz,Nx,[]); % + i*reshape(I(2:2:end),Nz,Nx,Ns*2);
clear I

I =  ii(:,:,1:Ns);
%dI = ii(:,:,Ns+1:end);
end



offs=zeros(Ns,Ns);
J=zeros; S=zeros;
  
if  1
for nn=1:length(si)
  ix=xi(nn);
  is=si(nn);
	corr=zeros(1,2*W+1);
	for dz=-W:W
	  for iz=zi(nn):zi(nn)+100
	    corr(dz+W+1)=corr(dz+W+1)+sum(I(iz+dz,ix,is)*I(iz,ix,(Ns+1)/2));
          end
          w1(dz+W+1) = (dz/W)^2;
          w2(dz+W+1) = -exp(-dz^2/sigma^2);
   	end
    	S(nn) = sum(corr.^2);
    	J(nn) = S(nn)^-1*sum(w2.*corr.^2);
    
	%[tmp tmpi]=max(corr);
	%offs(is,ix)=tmpi-W-1;
   
end
end %if

%JJ(:,:,mm) = J-J0;
AA(:,mm) = J(:);%-J0(:);

display(sprintf('Perturbation %d, J = %f',mm,sum(sum(J))))


end %loop over perturbations (mm)




BB=AA'*AA;
xx=AA'*(Jf(:));%-J0(:));
aww=(BB+eye)^-1*xx

Ng=8;c=7200*ones(Nz,Nx);
gx=[210., 310., 410., 510., 210., 310., 410., 510.];
gz=[200., 200., 200., 200., 300., 300., 300., 300.];
for ix = 1:Nx
for iz=1:Nz
for ig=1:Ng		
c(iz,ix)= c(iz,ix) + aww(ig)*exp(-(ix-gx(ig))^2/60^2-(iz-gz(ig))^2/60^2);
end;end;end





