%
%clear
path(path, '~/htomo/work/mbin');
%Nx=512;
Nx=1100;
Nw=80;
Nt=128;%256;%4096;
%Ns=32;
Ns=29;




Nx=720;Nz=560;Ns=29;src=80:10:640;
x0=60;xf=Nx-60;
z0=110;zf=Nz-50;

if 1

t=(0:Nt-1)*0.01;
w0=5; wf=60;
w=1:Nt;
Aw=exp(-((wf+w0)/2 - w).^2/((wf-w0)/5)^2);

data = zeros(Nt,Nz,Nx);src=data;
s1 = zeros(Nt,Nz,Nx);s0=s1;
r1=zeros(Nt,Nz,Nx);r0=r1;
uu=zeros(Nz,Nx,4);

I=loadbin('/scratch/lustreA/s/sburdic/data/Isub_Invwater','float');water=reshape(I,Ns,80);
I=loadbin('/scratch/lustreA/s/sburdic/data/Isub_Invasrc','float');I=reshape(I,Nz,Nx,[]);asrc=I(:,:,14);

for iw=w0:wf
  %fid=fopen(sprintf('/scratch/lustreA/s/sburdic/data/IbasicAfield%2d',iw));
  fid=fopen(sprintf('/scratch/lustreA/s/sburdic/data/Isub_InvAfield%2d',iw));
  U=fread(fid,'float');
  fclose(fid);
  uu=reshape(U(1:2:end),Nz,Nx,4) + i*reshape(U(2:2:end),Nz,Nx,4);
  
  
  
  for ix=1:Nx
    for iz =1:Nz
      %s1(iw,iz,ix)=uu(iz,ix,1);
      %r1(iw,iz,ix)=uu(iz,ix,2);
      s0(iw,iz,ix)=uu(iz,ix,3);
      r0(iw,iz,ix)=uu(iz,ix,4);       
    end
  end
  display(sprintf('iw = %d',iw))
end

end %if

if 1
for iw=w0:wf
  for ix=1:Nx
    for iz =1:Nz
	%if asrc(iz,ix)~=0
	r1(iw,iz,ix)= conj(s0(iw,iz,ix))/(conj(s0(iw,iz,ix))*s0(iw,iz,ix)+water(14,iw));
        s1(iw,iz,ix)=  conj(s0(iw,iz,ix))^2/(conj(s0(iw,iz,ix))^2*s0(iw,iz,ix)^2 +water(14,iw)^2); 
	%s1(iw,iz,ix)= asrc(iz,ix)*s1(iw,iz,ix);
	%end	      
    end
  end
  display(sprintf('iw = %d',iw))
end
end

if 1


adjS=real(ifft(s1));
adjR=real(ifft(r1));
S   =real(ifft(s0));
R   =real(ifft((r0)));
%for iw=1:1:Nt;figure(1);imagesc(real(squeeze(adjS(iw,:,:))));figure(2);imagesc(real(squeeze(R(iw,:,:))));drawnow;end


mR=max(abs(R(:)))/2;mS=max(abs(S(:)))/2;maR=max(abs(adjR(:)))/2;maS=max(abs(adjS(:)))/2;
for iw=1:2:Nt
  figure(1)
  subplot(2,2,1);imagesc(real(squeeze(S(iw,z0:zf,x0:xf))));caxis([-mS mS]);title('Forward source field');
  subplot(2,2,2);imagesc(real(squeeze(R(iw,z0:zf,x0:xf)))); caxis([-mR mR]);title('Forward receiver field');
  subplot(2,2,4);imagesc(real(squeeze(adjS(iw,z0:zf,x0:xf))));caxis([-maS maS]);title('Adjoint source field');
  subplot(2,2,3);imagesc(real(squeeze(adjR(iw,z0:zf,x0:xf))));caxis([-maR maR]);title('Adjoint receiver field');
  drawnow; 
end

break
mR=max(abs(R(:)))/2;mS=max(abs(S(:)))/2;maR=max(abs(adjR(:)));maS=max(abs(adjS(:)));
vs=linspace(-mS,mS,11);vr=linspace(-mR,mR,11);vs(5:7)=[];vr(5:7)=[];
for iw=1:2:Nt
  figure(3)
  subplot(1,2,1);imagesc(real(squeeze(adjS(iw,z0:zf,x0:xf))));caxis([-maS maS]);title('source field');hold on;
  subplot(1,2,2);imagesc(real(squeeze(adjR(iw,z0:zf,x0:xf)))); caxis([-maR maR]);title('receiver field');hold on
  subplot(1,2,1);contour(real(squeeze(S(iw,z0:zf,x0:xf))),vs,'k');axis equal tight;hold off
  subplot(1,2,2);contour(real(squeeze(R(iw,z0:zf,x0:xf))),vr,'k');axis equal tight;hold off
  drawnow; %pause
end





break

end %if 2






adjS=real(ifft(s1(:,z0:zf,320)));
adjR=real(ifft(r1(:,z0:zf,320)));
S   =real(fft(s0(:,z0:zf,320)));
R   =real(ifft((r0(:,z0:zf,320))));

%figure;imagesc(squeeze(real(sum(r1(:,z0:zf,x0:xf).*conj(r0(:,z0:zf,x0:xf)),1)))) ;axis equal tight;
%c=caxis;c=max(abs(c));caxis([-c c]);
%figure;imagesc(squeeze(real(sum(s1(:,z0:zf,x0:xf).*(s0(:,z0:zf,x0:xf)),1))));axis equal tight
%c=caxis;c=max(abs(c))/2;caxis([-c c]);

mR=max(abs(R(:)));mS=max(abs(S(:)));maR=max(abs(adjR(:)));maS=max(abs(adjS(:)));
for iw=1:2:Nt
  figure(2)
  subplot(2,2,1);plot(S(iw,:)/mS);hold on;plot(R(iw,:)/mR,'r');axis([0 400 -1 1]);hold off;
  %subplot(2,2,2);plot(R(iw,:));axis([0 400 -mR mR]);title('Forward receiver field');
  subplot(2,2,4);plot(adjR(iw,:)/maR);hold on;plot(R(iw,:)/mR,'r');axis([0 400 -1 1]);hold off;
  subplot(2,2,3);plot(adjS(iw,:)/maS);hold on;plot(conj(S(iw,:))/mS,'r');axis([0 400 -1 1]);hold off;
  drawnow; %pause
end






break
I=loadbin('/scratch/lustreA/s/sburdic/data/Ibasicvadj','float');ii=reshape(I,Nz,Nx,[]); % + i*reshape(I(2:2:end),Nz,Nx,Ns*2);
figure;imagesc(ii(z0:zf,x0:xf,14));axis equal tight;c=caxis;c=max(abs(c));caxis([-c c]);
title('Gradient contribution from event 14 source');xlabel('Offset');ylabel('Depth');
figure;imagesc(ii(z0:zf,x0:xf,14+29));axis equal tight;c=caxis;c=max(abs(c));caxis([-c c]);
title('Gradient contribution from event 14 data'  );xlabel('Offset');ylabel('Depth');

figure;imagesc(sum(ii(z0:zf,x0:xf,[1:19 21:28 30:48 50:57]),3));axis equal tight;c=caxis;c=max(abs(c));caxis([-c c]);
title('Total Gradient'  );xlabel('Offset');ylabel('Depth');

