clear
path(path, '~/htomo/work/mbin');



srcap = 300;

Nx=720;Nz=560;Ns=29;
src=srcap+1:10:Nx-srcap;


x0 = 61; xf = Nx-60;
z0 = 111; zf = Nz-50;

xi0=[];zi0=[];
Ixz=imread('~/htomo/work/models/vsub_I.bmp');
%Ixz=loadbin('~/htomo/work/models/scatbasic','float')';
Ixz=reshape(Ixz,Nz,Nx);

for ix=1:Nx;
    for iz=1:Nz
        if Ixz(iz,ix) < 254; xi0=[xi0 ix];zi0=[zi0 iz];end
    end
end



%Load unperturbed case to I0
I=loadbin('/scratch/lustreA/s/sburdic/data/Isub_Frech_low53PR 1','float');
ii=reshape(I,Nz,Nx,[]); % + i*reshape(I(2:2:end),Nz,Nx,Ns*2);
clear I
I0 =  ii;%(:,:,1:Ns);
I=loadbin('/scratch/lustreA/s/sburdic/data/Isub_Frech_low53PR17','float');
ii=reshape(I,Nz,Nx,[]);
clear I
If =  ii;%(:,:,1:Ns);


si1=[];si2=[];xi=[];zi=[];corrs=[];
for is2=[1:9 21:29]
    for is1=10:20

      for nn=1:length(xi0)
        ix=xi0(nn);
        iz=zi0(nn);
        corr=0;

        for iz=zi0(nn)-50:zi0(nn)+50
          corr=corr+sum(I0(iz,ix,is1)*I0(iz,ix,is2));
        end
        if corr>2.5e-2
          si1=[si1 is1];
          si2=[si2 is2];
          xi =[xi  xi0(nn) ];
          zi =[zi  zi0(nn) ];
        end
      end
    end
   
end

si1=loadbin('/scratch/lustreA/s/sburdic/data/Isub_Frech_low53s1','float');
si2=loadbin('/scratch/lustreA/s/sburdic/data/Isub_Frech_lows1','float');
xi=loadbin('/scratch/lustreA/s/sburdic/data/Isub_Frech_lowx','float');
zi=loadbin('/scratch/lustreA/s/sburdic/data/Isub_Frech_lowz','float');

%break



W=30;  
sigma = 15;


figure
J0=zeros; S=zeros; Jf=zeros; Sf=zeros;
for nn=1:length(si1)
  ix=xi(nn);
  is1=si1(nn);
  is2=si2(nn);  
	corr=zeros(1,2*W+1);
	corr2=zeros(1,2*W+1);
	corrf=zeros(1,2*W+1);
	for dz=-W:W
	  for iz=zi(nn)-50:zi(nn)+50
		if iz+dz<Nz & iz-dz<Nz
	      corr(dz+W+1)=corr(dz+W+1)+sum(I0(iz+dz,ix,is1)*I0(iz,ix,is2));
	      corr2(dz+W+1)=corr2(dz+W+1)+sum(I0(iz,ix,is1)*I0(iz-dz,ix,is2));
	      corrf(dz+W+1)=corrf(dz+W+1)+sum(If(iz+dz,ix,is1)*If(iz,ix,is2));
	      
        end
      end
          w1(dz+W+1) = (dz/W)^2;
          w2(dz+W+1) = -exp(-dz^2/sigma^2);
   	end
    	S(nn) = sum(corr.^2);
	Sf(nn) = sum(corrf.^2);
    	J0(nn) = S(nn)^-1*sum(w2.*corr.^2);
        Jf(nn) = Sf(nn)^-1*sum(w2.*corrf.^2);


end
display(sprintf('No perturbation, J = %f',sum(sum(J0))))
display(sprintf('Test case, J = %f',sum(sum(Jf))))

break

for mm=1:8


if 1
%ii=loadbin('/scratch/lustreA/s/sburdic/tmp/Iplane0S','float');
%I0=reshape(ii,Nz,Nx,[]); % + i*reshape(I(2:2:end),Nz,Nx,Ns*2);
%I=loadbin('/scratch/lustreA/s/sburdic/tmp/Iplane_adjPR0','float');
I=loadbin(['/scratch/lustreA/s/sburdic/data/Isub_inv2DPRS ' num2str(mm+1)],'float');
ii=reshape(I,Nz,Nx,[]); % + i*reshape(I(2:2:end),Nz,Nx,Ns*2);
clear I

I =  ii(:,:,1:Ns);
%dI = ii(:,:,Ns+1:end);
end



offs=zeros(Ns,Ns);
J=zeros; S=zeros;
  
if  1
for nn=1:length(si1)
  ix=xi(nn);
  is1=si1(nn);
  is2=si2(nn);  
	corr=zeros(1,2*W+1);
	for dz=-W:W
	  for iz=zi(nn)-50:zi(nn)+50
        if iz+dz<Nz
	      corr(dz+W+1)=corr(dz+W+1)+sum(I(iz+dz,ix,is1)*I(iz,ix,is2));
        end
      end
      w1(dz+W+1) = (dz/W)^2;
      w2(dz+W+1) = -exp(-dz^2/sigma^2);
   	end
    	S(nn) = sum(corr.^2);
    	J(nn) = S(nn)^-1*sum(w2.*corr.^2);
    
	%[tmp tmpi]=max(corr);
	%offs(is,ix)=tmpi-W-1;
   
end
end %if

%JJ(:,:,mm) = J-J0;
AA(:,mm) = J(:);%-J0(:);

display(sprintf('Perturbation %d, J = %f',mm,sum(sum(J))))


end %loop over perturbations (mm)




BB=AA'*AA;
xx=AA'*(Jf(:));%-J0(:));
aww=(BB+eye)^-1*xx

Ng=8;c=zeros(Nz,Nx);%7200*ones(Nz,Nx);
gx=[210., 310., 410., 510., 210., 310., 410., 510.];
gz=[200., 200., 200., 200., 300., 300., 300., 300.];
awwt=[-2 2 -2 2 2 -2 2 -2];
for ix = 1:Nx
for iz=1:Nz
for ig=1:Ng		
c(iz,ix)= c(iz,ix) + 100*aww(ig)*exp(-(ix-gx(ig))^2/40^2-(iz-gz(ig))^2/40^2);
end;end;end
figure;imagesc(0:(xf-x0)/4,0:(zf-z0)/4,c(z0:zf,x0:xf));axis equal tight





