%
clear
path(path, './mbin');

x0=60;
z0=110;
Nx=600+x0*2
Nz=400+z0+50

%x=linspace(0,(Nx-1)/2,Nx);
%z=linspace(0,(Nz-1)/4,Nz);

c0=7200*ones(Nz,Nx);
c=zeros(Nz,Nx);%c0;
dc=zeros(Nz,Nx);

Ng=8;
ag=[-200., 200., -200., 200., 200., -200., 200., -200.]; 
gx=[210., 310., 410., 510., 210., 310., 410., 510.];
gz=[200., 200., 200., 200., 300., 300., 300., 300.];




  for ix = 1:Nx
	for iz=1:Nz
	for ig=1:Ng
		% Model with two gaussian blobs
		c(iz,ix)= c(iz,ix) + ag(ig)*exp(-(ix-gx(ig))^2/40^2-(iz-gz(ig))^2/40^2);


		% Model
		%c(ix,iz)=7200 + 200*sin(pi*(iz-700.)/70) - 100*sin(pi*(ix-200-xtra)/500);
	end
	end
	for iz = x0:Nx-x0
	dc(140 + z0,iz) = dc(140+z0,iz) + exp(-(ix-iz)^2/8^2);
	dc(240 + z0,iz) = dc(240+z0,iz) + exp(-(ix-iz)^2/8^2);
	dc(340 + z0,iz) = dc(340+z0,iz) + exp(-(ix-iz)^2/8^2);
	end
  end

  dc = 0.08 / max(dc(:))*dc ;



%savebin(c(:),'models/vel.5','float');
%savebin(c0(:),'models/vel0.5','float');
%savebin(dc(:),'models/dv.5','float');

